﻿@model IEnumerable<EPPW.Membership.Dto.ProgramDto>
@{
    ViewBag.Title = "RoleHasPrograms";
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
}
@section HeadCss
{
    @Styles.Render("~/Content/plugins/datatables")
}
@section SideContent
{
    <div class="row-fluid">
        <div class="span12">
            <blockquote>
                <p>
                    Role</p>
                <small>@ViewBag.RoleName</small>
            </blockquote>
        </div>
    </div>
}
<div class="row-fluid">
    <div class="span2">
    </div>
    <div class="span8">
        <p>
            <a href="#AddProgramModal" class="btn btn-small" role="button" data-toggle="modal"><i
                class="icon-plus"></i>Program</a>
        </p>
        <legend>Role Has Programs</legend>
        <table id="RoleHasProgramsTable" class="table table-bordered zebra-striped dataTable table-hover table-condensed">
            <thead>
                <tr role="row">
                    <th class="header" role="columnheader" tabindex="0" aria-controls="RoleHasProgramsTable"
                        rowspan="1" colspan="1" style="width: 106px;">
                        Program Code
                    </th>
                    <th class="header" role="columnheader" tabindex="0" aria-controls="RoleHasProgramsTable"
                        rowspan="1" colspan="1" style="width: 30px;">
                        Program Name
                    </th>
                    <th class="header" role="columnheader" tabindex="0" aria-controls="RoleHasProgramsTable"
                        rowspan="1" colspan="1" style="width: 106px;">
                        IsUsed
                    </th>
                </tr>
            </thead>
            <tbody>
                @if (Model == null)
                {
                    <tr>
                        <td colspan="4">
                            <p>
                                没有查询的数据。</p>
                        </td>
                    </tr>
                }
                else
                {
                    foreach (EPPW.Membership.Dto.ProgramDto item in Model)
                    {
                    <tr>
                        <td>@Html.DisplayFor(modelItem => item.Code)
                        </td>
                        <td>@Html.DisplayFor(modelItem => item.Name)
                        </td>
                        <td>@Html.DisplayFor(modelItem => item.IsUsed)
                        </td>
                    </tr>
                    }
                }
            </tbody>
        </table>
        <div>
            @Html.ActionLink("Back to List", "Index")
        </div>
    </div>
    <div class="span2">
    </div>
</div>
<div id="AddProgramModal" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="AddProgramLabel"
    aria-hidden="true">
    <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">
            ×</button>
        <h3 id="AddProgramLabel">
            Add Program</h3>
    </div>
    <div class="modal-body">
        <table id="AddProgramTable" class="table table-bordered zebra-striped dataTable table-hover table-condensed">
            <thead>
                <tr>
                    <th style="width: 10px;">
                        Select
                    </th>
                    <th class="header" role="columnheader" tabindex="0" aria-controls="AddProgramTable"
                        rowspan="1" colspan="1" style="width: 30px;">
                        Code
                    </th>
                    <th class="header" role="columnheader" tabindex="0" aria-controls="AddProgramTable"
                        rowspan="1" colspan="1" style="width: 30px;">
                        Name
                    </th>
                    <th class="header" role="columnheader" tabindex="0" aria-controls="AddProgramTable"
                        rowspan="1" colspan="1" style="width: 60px;">
                        Desc
                    </th>
                </tr>
            </thead>
            <tbody>
            </tbody>
        </table>
    </div>
    <div class="modal-footer">
        <button class="btn" data-dismiss="modal" aria-hidden="true">
            Close</button>
        <button id="btnAddProgram" type="button" class="btn btn-primary">
            Save changes</button>
    </div>
    <div id="divRoleProgramId">
        @foreach (var program in Model)
        {
            @Html.Hidden("roleProgramId", program.ProgramId, "");
        }
    </div>
</div>
@section Scripts {
    @Scripts.Render("~/Scripts/Plugins/datatables")
    <script type="text/javascript" language="javascript">
        var modifyProgramList = [];
        $(function () {

            $('#AddProgramModal').on('show', function () {
                $('#AddProgramTable').dataTable({
                    "bRetrieve": true,
                    "bProcessing":true,
                    "sAjaxSource": '@Url.Action("ProgramListByRole", "AdminProgram", new { id = ViewBag.RoleId })',
                    "fnDrawCallback": function () {
                        setChecked();
                        $("#AddProgramTable>tbody").find(":checkbox").on("change", function () {

                            var isFind = false;
                            var FindItem;
                            for (var i = 0; i < modifyProgramList.length; i++) {
                                if (modifyProgramList[i].ProgramId == $(this).val()) {
                                    isFind = true;
                                    FindItem = modifyProgramList[i];
                                    break;
                                }
                            }
                            if (isFind == false) modifyProgramList.push({ ProgramId: $(this).val(), Status: $(this).is(":checked") ? 1 : 2 })
                            else 
                            {
                             modifyProgramList.pop(FindItem);
                            }

                        });
                    },
                    "aoColumns": [
                        { "mData": "check" },
                        { "mData": "Code" },
                        { "mData": "Name" },
                        { "mData": "Desc" }
                    ]
                });

                $("#btnAddProgram").on("click", function () {
                    var url = "@Url.Action("Program", "AdminRole", new { id = ViewBag.RoleId })";
                    $.post(url, { data: JSON.stringify(modifyProgramList) }, function () {
                        window.location.reload(true);
                    }, "json");
                });


            });
             $('#AddProgramModal').on("hide",function(){
                setChecked();
                modifyProgramList=[];
            });
                function setChecked(){
                        var checkboxList=$("#AddProgramTable>tbody").find(":checkbox");
                        if(checkboxList.length==0)return;
                        checkboxList.each(function(){
                            $(this)[0].checked=false;
                            var roleProgramIdList=$("#divRoleProgramId").find("input[name='roleProgramId']");
                            for (var i = 0; i < roleProgramIdList.length; i++) {
                                if($(this).val()==$(roleProgramIdList[i]).val())
                                {
                                    $(this)[0].checked=true;
                                    break;
                                }
                            }
                        });
         }

        });
     
    </script>
}
